package geometry.part6;

import java.awt.geom.Point2D;

public class GeomUtils {
    public static double cross(double x1, double y1, double x2, double y2) {
        return x1 * y2 - x2 * y1;
    }

    public static double cross(Point2D p1, Point2D p2) {
        return cross(p1.getX(), p1.getY(), p2.getX(), p2.getY());
    }

    public static double dot(double x1, double y1, double x2, double y2) {
        return x1 * x2 + y2 * y2;
    }

    public static double dot(Point2D p1, Point2D p2) {
        return dot(p1.getX(), p1.getY(), p2.getX(), p2.getY());
    }

    // (x1, y1) -> (x2, y2) -> (x3, y3) と進む道のりが半時計回りの場合は正の値、
    // 時計回りの場合は負の値、一直線上の場合はゼロを返す
    public static double ccw(double x1, double y1, double x2, double y2,
            double x3, double y3) {
        return cross(x2 - x1, y2 - y1, x3 - x2, y3 - y2);
    }

    public static double ccw(Point2D p1, Point2D p2, Point2D p3) {
        return ccw(p1.getX(), p1.getY(), p2.getX(), p2.getY(), p3.getX(), p3
                .getY());
    }
}
